//------------------------------------------------------------------------------
//  1st Dialogs Library: 1.0 
//  Copyright  2000 Digital Accuracy
//  Created            : 16-10-2000
//  Last Modification  : 22-10-2000
//  Description        : 1st Dialogs Library Demo Form
//------------------------------------------------------------------------------

unit DemoU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, ImgList, StdCtrls, TipofDay, AboutBox, ExtDlgs,
  Buttons;

type
  TDlgsDADemoWnd = class(TForm)
    imgApp: TImage;
    bvlSep: TBevel;
    pgcDemo: TPageControl;
    tsAboutBox: TTabSheet;
    tsTipofDay: TTabSheet;
    ilTabs: TImageList;
    AboutBox: TAboutBox;
    Bevel3: TBevel;
    TipofDay: TTipofDay;
    btnExecute: TButton;

    bvlAboutBox: TBevel;
    lblAppName: TLabel;
    lblCopyright: TLabel;
    lblUrl: TLabel;
    lblUserName: TLabel;
    lblSerialNo: TLabel;
    gpbLicense: TGroupBox;
    gpbAddInfo: TGroupBox;
    gpbAboutOptions: TGroupBox;
    gpbSysInfo: TRadioGroup;
    edtAppName: TEdit;
    edtCopyright: TEdit;
    edtUrl: TEdit;
    edtAddInfo: TMemo;
    edtUserName: TEdit;
    edtSerialNo: TEdit;
    chkShowUrl: TCheckBox;
    chkShowLicense: TCheckBox;
    chkShowWarning: TCheckBox;
    chkShowVersion: TCheckBox;
    chkTransparent: TCheckBox;
    gpbSecretInfo: TGroupBox;
    gpbPicture: TGroupBox;
    imgAB: TImage;
    btnimage: TButton;
    OpenDlg: TOpenPictureDialog;
    edtShortCut: THotKey;
    edtSecret: TMemo;
    lblSecret: TLabel;
    lblShortCut: TLabel;
    pnlSecretTest: TPanel;
    btnSecretColor: TButton;
    btnSecretFont: TButton;
    FontDlg: TFontDialog;
    ColorDlg: TColorDialog;

    MiscTipOptions: TGroupBox;
    chkStartup: TCheckBox;
    chkNext: TCheckBox;
    chkHelp: TCheckBox;
    chkPrev: TCheckBox;
    chkLoop: TCheckBox;
    gpbMisc: TGroupBox;
    lblDialogTitle: TLabel;
    edtDialogTitle: TEdit;
    Label2: TLabel;
    edtTipTitle: TEdit;
    pnlTipText: TPanel;
    btnTipTextFont: TButton;
    pnlTipTitle: TPanel;
    btnTipTitleFont: TButton;
    Label3: TLabel;
    Label4: TLabel;
    gpbTipList: TGroupBox;
    edtTipList: TMemo;
    AboutDA: TAboutBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    lblEndofTip: TLabel;
    edtLineBreak: TEdit;
    procedure btnExecuteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnimageClick(Sender: TObject);
    procedure btnSecretColorClick(Sender: TObject);
    procedure btnSecretFontClick(Sender: TObject);
    procedure btnTipTextFontClick(Sender: TObject);
    procedure btnTipTitleFontClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    procedure PrepareAboutBox;
    procedure PrepareTipOfDay;
  public
    { Public declarations }
  end;

var
  DlgsDADemoWnd: TDlgsDADemoWnd;

implementation

{$R *.DFM}

uses Registry;

procedure TDlgsDADemoWnd.FormCreate(Sender: TObject);
var
  User, ID: string;
begin
  // Getting User Informations
  User := 'Demo Copy';
  ID := 'xxxxx-xxx-xxxxxxx-xxxxx';
  with TRegistry.Create do
    try
      RootKey := HKEY_LOCAL_MACHINE;
      if OpenKey('\Software\Microsoft\Windows\CurrentVersion', True) then
      begin
        ID := ReadString('ProductId');
        User := ReadString('RegisteredOwner');
      end;
    finally
      CloseKey;
      Free;
    end;
  AboutDA.UserName := User;
  AboutDA.SerialNo := ID;
  edtUserName.Text := User;
  edtSerialNo.Text := ID;
  pnlSecretTest.Font.Assign(AboutBox.SecretInfoOptions.Font);
  pnlTipText.Font.Assign(TipOfDay.TipTextFont);
  pnlTipTitle.Font.Assign(TipOfDay.TipTitleFont);
  Application.HintHidePause := 10500;
  // Assigning Tips
  edtTipList.Lines.Assign(TipofDay.Tips);
end;

procedure TDlgsDADemoWnd.btnExecuteClick(Sender: TObject);
begin
  if pgcDemo.ActivePage = tsAboutBox then
  begin
    PrepareAboutBox;
    AboutBox.Execute;
  end
  else
  begin
    PrepareTipOfDay;
    TipOfDay.Execute;
  end;
end;

procedure TDlgsDADemoWnd.btnimageClick(Sender: TObject);
begin
  if OpenDlg.Execute then
    imgAB.Picture.LoadFromFile(OpenDlg.FileName);
end;

procedure TDlgsDADemoWnd.btnSecretColorClick(Sender: TObject);
begin
  ColorDlg.Color := pnlSecretTest.Color;
  if ColorDlg.Execute then
    pnlSecretTest.Color := ColorDlg.Color;
end;

procedure TDlgsDADemoWnd.btnSecretFontClick(Sender: TObject);
begin
  FontDlg.Font.Assign(pnlSecretTest.Font);
  if FontDlg.Execute then
    pnlSecretTest.Font.Assign(FontDlg.Font);
end;

procedure TDlgsDADemoWnd.btnTipTextFontClick(Sender: TObject);
begin
  FontDlg.Font.Assign(pnlTipText.Font);
  if FontDlg.Execute then
    pnlTipText.Font.Assign(FontDlg.Font);
end;

procedure TDlgsDADemoWnd.btnTipTitleFontClick(Sender: TObject);
begin
  FontDlg.Font.Assign(pnlTipTitle.Font);
  if FontDlg.Execute then
    pnlTipTitle.Font.Assign(FontDlg.Font);
end;

procedure TDlgsDADemoWnd.PrepareAboutBox;
begin
  with AboutBox do
  begin
    AppName := edtAppName.Text;
    Copyright := edtCopyright.Text;
    Url := edtUrl.Text;
    AdditionalInfo.Text := edtAddInfo.Lines.Text;
    UserName := edtUserName.Text;
    SerialNo := edtSerialNo.Text;
    Options := [];
    if chkShowUrl.Checked then
      Options := Options + [aboShowUrl];
    if chkShowVersion.Checked then
      Options := Options + [aboShowVersion];
    if chkShowLicense.Checked then
      Options := Options + [aboShowLicense];
    if chkShowWarning.Checked then
      Options := Options + [aboShowWarning];
    if chkTransparent.Checked then
      Options := Options + [aboTransparentImage];
    SystemInfoState := TSystemInfoState(gpbSysInfo.ItemIndex);
    Picture.Assign(imgAB.Picture);
    with SecretInfoOptions do
    begin
      Color := pnlSecretTest.Color;
      Font.Assign(pnlSecretTest.Font);
      ShortCut := edtShortCut.HotKey;
      Info.Assign(edtSecret.Lines);
    end;
  end;
end;

procedure TDlgsDADemoWnd.PrepareTipOfDay;
begin
  with TipofDay do
  begin
    DialogTitle := edtDialogTitle.Text;
    TipTitle := edtTipTitle.Text;
    TipOfDay.TipTextFont.Assign(pnlTipText.Font);
    TipOfDay.TipTitleFont.Assign(pnlTipTitle.Font);
    TipOfDay.Tips.Assign(edtTipList.Lines);
    Options := [];
    if chkStartup.Checked then
      Options := Options + [tdoShowStartupCheck];
    if chkPrev.Checked then
      Options := Options + [tdoShowPrev];
    if chkNext.Checked then
      Options := Options + [tdoShowNext];
    if chkHelp.Checked then
      Options := Options + [tdoShowHelp];
    if chkLoop.Checked then
      Options := Options + [tdoLoopTips];
    LineBreak := edtLineBreak.Text;
  end;
end;

procedure TDlgsDADemoWnd.SpeedButton1Click(Sender: TObject);
begin
  AboutDA.Execute;
end;

procedure TDlgsDADemoWnd.SpeedButton2Click(Sender: TObject);
begin
  Close;
end;

end.
